#!/bin/bash

# Function to check if the user has sudo privileges
check_sudo() {
  if sudo -n true 2>/dev/null; then
    echo "You have sudo privileges."
  else
    echo "This script requires sudo privileges."
    echo "Please enter your password to continue."
    
    # Prompt the user for sudo access
    if ! sudo -v; then
      echo "Failed to acquire sudo privileges. Exiting."
      exit 1
    fi
  fi
}

check_sudo

echo Updating repositories...
sudo apt update
sudo apt install software-properties-common -y
sudo add-apt-repository ppa:deadsnakes/ppa -y
sudo apt update
echo Installing python...
sudo apt install python3.11 python3.11-venv -y
sudo mkdir $(dirname "$0")/python311
sudo ln -s /usr/bin/python3.11 $(dirname "$0")/python311/python

echo "Press any key to exit..."
read -n1 -s  # Waits for one key press without echoing it to the terminal